/*  config.h  (C) 1997 Mark A. Livingston */
/* Any non-commercial use of this code is permitted so long as */
/* the above copyright line appears in the file.  Please contact */
/* the author regarding permission for commercial use. */
typedef struct {
  /* jitter maximums, in meters */
  double posMaxFOB, posMaxFaro;
  double oriMaxFOB, oriMaxFaro;

  /* kernel parameters, in meters */
  double kernelRadius;
  double kernelSigma;

  /* grid points acceptance */
  int    minPoints;
  double minWeight;
  double cogDistance;

  /* grid position and resolution */
  double xMin, xMax;
  double yMin, yMax;
  double zMin, zMax;
  int    xSteps, ySteps, zSteps;

  /* data and transformation files */
  int    numDataFiles;
  char **sampFile, **transFile;
  int   *nPts, totalPts;
  int   *nSampFOB, *nSampFARO;

  /* verbosity flag */
  int verbose;
  /* output repository */
  FILE *outfp;
} ConfigRec;

/* function declarations for config.c */
ConfigRec *ParseConfigFile( char *fname, int verbose, char *outFile );
